
#include <windows.h>

#import "c:\Program Files\TradeStation 8.1 (Build 3159)\Program\tskit.dll" no_namespace
#import "c:\WINDOWS\system32\InteropDemo_VBCode.tlb" raw_interfaces_only no_namespace


// Constants
#define UNDEFINED_ERR 10
#define KIT_COM_ERROR 20


//  Internal function prototypes
BSTR __stdcall fnLPSTRtoBSTR( LPSTR szInString ) ;
void fnGenRuntimeError( IEasyLanguageObject * pEL, int iErrorNum ) ;


// DLL Main
BOOL __stdcall DllMain(HANDLE hModule,
					   DWORD ul_reason_for_call,
					   LPVOID lpReserved
					   )
{
	switch( ul_reason_for_call )
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
		break; 
	}
	return TRUE ;
}


// Internal-use functions
BSTR __stdcall fnLPSTRtoBSTR( LPSTR szInString )
{
	int nSize ;
	nSize = MultiByteToWideChar(CP_ACP, 0, szInString, -1, NULL, 0) ;
	WCHAR* wszUniString ;
	wszUniString = new WCHAR[nSize] ;
	MultiByteToWideChar(CP_ACP, 0, szInString, -1, wszUniString, nSize) ;
	BSTR bstrOutString ;
	bstrOutString = SysAllocString( wszUniString ) ;
	delete[] wszUniString ;
	return bstrOutString ;
}

//  Generate a run-time error in TradeStation
void fnGenRuntimeError
( IEasyLanguageObject * pEL, int iErrorNum )
{
	TSRuntimeErrorItem tsItem;
	int m_HistErr ;
	tsItem.sCompany = _bstr_t("TradeStation Securities, Inc.").copy();
	tsItem.sErrorLocation = _bstr_t("VB Interop Demo Library").copy();
	tsItem.sErrorCategory = _bstr_t("Error").copy();
	tsItem.sLongString = NULL;
	tsItem.nParameters = 0;
		
    switch ( iErrorNum )
	{
		case KIT_COM_ERROR:
		{
			// A call to a tskit method or property generated an error
			tsItem.sShortString = _bstr_t("Error - TSKit call generated"
				" COM error.").copy();
			tsItem.nErrorCode = KIT_COM_ERROR ;
			break ;
		}
		default:
		{
			// Generate a run-time error of undefined type or origin
			tsItem.sShortString = _bstr_t("Undefined error in "
				"COMInteropDemo.dll.").copy();
			tsItem.sSourceString = _bstr_t("Error origin undefined.").copy();
			tsItem.nErrorCode = UNDEFINED_ERR ;
		}
	}
	m_HistErr = pEL->Errors->RegisterError( &tsItem ) ;
	pEL->Errors->RaiseRuntimeError( m_HistErr ) ;
}


// Exported function(s)
int __stdcall CallMyVBAvg(IEasyLanguageObject* pEL,
							 int nLength,
							 LPSTR szELVarName)
{
	_InteropDemo_VBClass* pNetClass ;
	_InteropDemo_VBClassPtr p(__uuidof(InteropDemo_VBClass)) ;
	pNetClass = p ;
	long nRetVal ;
	BSTR bstrELVarName ;
	bstrELVarName = fnLPSTRtoBSTR( szELVarName ) ;
	HRESULT hr = S_OK ;
	hr = pNetClass->MyVBAvg( pEL, nLength, bstrELVarName, &nRetVal ) ;
	p = NULL ;
	if (FAILED(hr)) {
		fnGenRuntimeError( pEL, KIT_COM_ERROR ) ;  
	}
	return nRetVal ;
} 
